<?php
session_name("InterfaceWebTM");
session_cache_expire (30);
session_start();

header("Cache-Control: no-cache, must-revalidate");
header('Content-Type: text/html; charset=UTF-8'); 

require_once('config.php');
require_once('GbxRemote.inc.php');
require_once('connection.php');
if(isset($_SESSION['lang_perso'])) require_once("lang/".$_SESSION['lang_perso'].".php");
else require_once("lang/".LANG_DEFAULT.".php");

//----------------------

function no_fast($line) {
	if($_SESSION['No_Fast'] != 1) return $line;
	//else
	$first_char = substr(utf8_decode($line), 0, 1);
	if($first_char == "[") return $line;
	elseif($first_char == "/") return $line;
	elseif(substr($line, 0, 25) == "Invalid time: the race of") return $line;
	elseif($first_char == "?") return $line;
	//else return "FAST - ".$line; //debug
}

function Max_Maj($text_b) {
  if (eregi("^\[[^]].+\] (.*)",$text_b,$text_b)) {
   $line = $text_b[1];
   $maj = 0;$max_maj = 60;
   $char_max = strlen(str_replace(" ","",$line)); $len_max = strlen($line);
   $char_max = ($char_max == 0)? -1 : $char_max;
   //$spe_char = '\+|\.|\\|\/|\*|\?|\(|\)|\^|\'|\"|\\$|\[|\]';
   $spe_char = '\+|\.|\\|\/|\*|\?|\(|\)|\^|\'|\"|\||\\$|\[|\]';

   for ($pos=0; $pos < $len_max;$pos++) {
     $char = substr($line,$pos,1);
     if (eregi($spe_char,$char)) { $char = "\\".$char; }
      if (eregi($char.'{4,}',$line)) {
       return true;
      }
      elseif (ereg('[A-Z^ ]',$char)) { $maj++; }
   }
   if (round(($maj*100)/$char_max) >= $max_maj) { return true; }
   else { return false; }
  }
  return false;
}

function chat_links($text, $pseudo_joueur) {
	global $Insults, $lang_b;
	//$text = texte_chat($text);
	if($pseudo_joueur != $_SESSION['pseudo'] AND $pseudo_joueur != "???") {
		for ($n=0;$n < (count($Insults));$n++) {
			if( (preg_match('/\b('.$Insults[$n].')\b/i',$text)) OR (Max_Maj($text)) ) {
				$text = '<font color="red">'.$text.'</font> - [<a href="?aff=chat&Kick='.urlencode($pseudo_joueur).'">'.$lang_b['Kick'][0].'</a>] [<a href="?aff=chat&Ban='.urlencode($pseudo_joueur).'">'.$lang_b['Ban'][0].'</a>]';
				break;
			}
			
		}
	}
	return $text;
}

// ----------------------------------

if(!$client->query("Authenticate", $_SESSION['authLogin'][$_SESSION['serveur']], $_SESSION['authPassword'][$_SESSION['serveur']])) {
	echo "<center>";
	trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	echo "</center>";
}
else {
	if($_GET['do'] == 'GetChatLines') {
		if (!$client->query('GetChatLines')) {
			   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
		}
		else {
			$GetChatLines = $client->getResponse();
			$chat = "<p style=\"text-align:left; padding:none; padding-left:3em; margin:none;\" >";
			foreach($GetChatLines AS $line) {
				eregi('\[([^]].+)\]', texte_chat($line), $pseudo_joueur);
				$line2 = no_fast(texte_chat($line));
				if(!empty($line2)) $chat .= "<br />\n".chat_links($line2, $pseudo_joueur[1]);
			}
			$chat .= "</p>";
			echo $chat;
		}
	}
	else {
		if(substr(utf8_encode($_POST['ChatText']), 0, 1) == "/") $message = StripS(utf8_encode($_POST['ChatText']));
		elseif(isset($_SESSION['pseudo'])) $message = "[".$_SESSION['pseudo']."] ".StripS(utf8_encode($_POST['ChatText']));
		else $message = "[".PSEUDO_DEFAULT."] ".StripS(utf8_encode($_POST['ChatText']));
		
		//$message = (!isset($_SESSION['pseudo']) OR substr(utf8_encode($_POST['ChatText']), 0, 1) != "/") ? StripS(utf8_encode($_POST['ChatText'])) : "[".$_SESSION['pseudo']."] ".StripS(utf8_encode($_POST['ChatText']));
		if (!$client->query('ChatSendServerMessage', $message)) trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
}
//$client->Terminate();
?>
