<?php
// Fichier de fonctions

function GetDirectory($type) {
	global $client;
	if (!$client->query($type)) return 0; //trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	else return $client->getResponse();
}

function browse($pDirectory, $pExtension) {
    if($handle = opendir($pDirectory)) {
        while(false !== ($file = readdir($handle))) {
            $getExt = explode(".", $file);
            $countExt = count($getExt);
            $fExt = $countExt - 1;
            $myExt = $getExt[$fExt];
            
            if (($myExt == $pExtension) && ($file != ".") && ($file != "..")) {
				$files[] = $file;
			}
        }
		if(!isset($files)) $files = null;
    }
	return $files;    
	closedir($handle);
}

function browse_d($rep) {
 $dir = opendir($rep);
	while ($f = readdir($dir)) {
		if ($f !='.' && $f != '..') {
			if(is_dir($rep."/".$f)) {
				$list_dir[] = $f;
			}
		}
		if(!isset($list_dir)) $list_dir = null;
	}
	return $list_dir;
closedir($dir);
}

function ListFolder($Folder) { // Fonction pour lister les dossier
$dir = opendir($Folder);
while (false !== ($Current = readdir($dir))) // Boucle sur tout ce qu'il y a dans le répertoire
 {
 if ($Current !='.' && $Current != '..')
 {
	if(is_dir($Folder."/".$Current)) // Si c'est un dossier
    {
	//$dossier = substr($Folder.$Current, strlen(GameDataDirectory));
    echo '<option value="'.$Folder.$Current.'">'.$Folder.$Current.'</option>';
    ListFolder($Folder.$Current."/"); // On liste les dossiers contenue dans le dossier (récursivité)
    }
   }
  }
  closedir($dir);
}

function kick_ban_fast($action, $pseudo_joueur) {
	global $client;
	if (!$client->query('GetPlayerList', 50, 0)) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	$PlayerList = $client->getResponse();
	foreach($PlayerList as $Player) {
		if(texte_chat($Player['NickName']) == $pseudo_joueur) {
			if (!$client->query($action, $Player['Login'])) trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
			break;
		}
	}
}

function class_ligne($nb){
	if(is_float($nb/2)) return "ligne1";
	else return "ligne2";
}

//Transformation d'un temps de ms en minutes:secondes
function MwTimeToString($MwTime) {
	if ($MwTime == -1) {
		return "???";
	} else {
		$minutes = floor($MwTime/(1000*60));
		$seconds = floor(($MwTime-$minutes*60*1000)/1000);
		$mseconds = substr($MwTime,strlen($MwTime)-3,2);
		return sprintf("%02d:%02d.%02d", $minutes, $seconds, $mseconds);
	}
}

//formulaire de connexion au serveur
function formulaire_connexion() {
	global $lang, $lang_b, $serveur_default;
	$serveurs = liste_serveurs();
	echo '<center><form name="input" action="index.php" method="post">
		<table style="background-color: white; width:40%; margin: 10% 0">
			<tr>
				<td>Serveur</td>
				<td><select name="serveur">';
					for($i=1; $i<= count($serveurs); $i++) {
						echo "<option value=\"$i\"";
						if($i == $serveur_default AND empty($_POST['serveur'])) echo ' selected';
						elseif($i == $_POST['serveur']  AND !empty($_POST['serveur'])) echo ' selected';
						echo ">{$serveurs[$i]}</option>";
					}
			echo '</select></td>
			<td rowspan="3"><input type="submit" value="'.$lang_b['Authenticate'][0].'" title="'.$lang_b['Authenticate'][1].'"></td>
			</tr>
			<tr>
				<td>'.$lang['Permission_Level'].'</td>
				<td>
					<SELECT name="authLogin" >
						<option value="SuperAdmin" selected>SuperAdmin</option>
						<option value="Admin">Admin</option>
						<option value="User">User</option>
					</SELECT>
				</td>
			</tr>
			<tr>
				<td>'.$lang['Password'].'</td>
				<td><input type="password" name="authPassword" size="30" /></td>
			</tr>
		</table>
		
	</form></center>';
}

function general(){
	global $client, $lang, $lang_b;

	if (!$client->query('GetVersion')) trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	else {
		$Version = $client->getResponse();
		$version_titre = $lang['Connected_to']." " . $Version['Name']. " - " . $Version['Version'] . "<br />";
	}
		
		echo '<div class="rub">
		<p class="titre">'.$lang['Server_Status'].' - '.$version_titre.'</p>
			<div class="texte">
				';
			
			echo '<p id="zoneStatut" style="margin-top: 0; padding: none;"><span style="color:red; font-weight:bold; padding:none">'.$lang['PleaseWait'].'</span></p>';
			echo '<form name="actualiser" id="actualiser"><input name="auto" type="checkbox" onClick="automatique();" style="display: none" checked></form>';
			//echo '<input name="charger" value="'.$lang['Refresh'].'" onClick="chargeStatut();" type="button">';
				$lang_file = browse('lang', 'php');
				echo '
				<form name="lang_perso" action="index.php" method="post" style="text-align: center">
					'.$lang['lang_perso'].'
					<select name="lang_perso">';
					foreach($lang_file as $value) {
						$value = substr($value, 0, 2);
						echo '<option value="'.$value.'"';
						if(empty($_SESSION['lang_perso']) AND $value == LANG_DEFAULT) echo ' selected';
						elseif($value == $_SESSION['lang_perso']) echo ' selected';
						echo '>'.$value.'</option>';
					}
					echo '</select>
					<input type="submit" value="'.$lang_b['Save'][0].'"  title="'.$lang_b['Save'][1].'">
				</form>';
				
	echo "</div>
	</div>";
	
	//Network
	if (!$client->query('GetNetworkStats')) trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	else {
		$Network = $client->getResponse();
		$date = $Network['Uptime'];
		$time_j = date("j", $date) - 1;
		$time_H = (date("H", $date) != 0) ? date("H", $date) - 1 : 23;
		$time_i = date("i", $date);
		$time_s = date("s", $date);
		$time = $time_j." jour(s) et ".$time_H.":".$time_i.":".$time_s;
		
		echo '
		<div class="rub">
			<p class="titre">'.$lang['Network'].'</p>
			<p class="texte">
				<table>
					<tr>
						<td style="width: 300px">'.$lang['Uptime'].'</td>
						<td>'.$time.'</td>
					</tr>
					<tr>
						<td>'.$lang['NbrConnection'].'</td>
						<td>'.$Network['NbrConnection'].'</td>
					</tr>
					<tr>
						<td>'.$lang['MeanConnectionTime'].'</td>
						<td>'.($Network['MeanConnectionTime']).'</td>
					</tr>
					<tr>
						<td>'.$lang['MeanNbrPlayer'].'</td>
						<td>'.$Network['MeanNbrPlayer'].'</td>
					</tr>
					<tr>
						<td>'.$lang['RecvNetRate'].'</td>
						<td>'.$Network['RecvNetRate'].'</td>
					</tr>
					<tr>
						<td>'.$lang['SendNetRate'].'</td>
						<td>'.$Network['SendNetRate'].'</td>
					</tr>
					<tr>
						<td>'.$lang['TotalReceivingSize'].'</td>
						<td>'.$Network['TotalReceivingSize'].'</td>
					</tr>
					<tr>
						<td>'.$lang['TotalSendingSize'].'</td>
						<td>'.$Network['TotalSendingSize'].'</td>
					</tr>
				</table>
			</p>
		</div>';
	}
}

function players() {
	global $client, $lang, $lang_b;
	
	if(!isset($_GET['aff_chat_player'])) $visibility = 'display : none;';
	else $visibility ="";
	echo '<div class="chat_player" style="'.$visibility.'">
		<p class="titre">'.$_POST['PlayerLogin'].'</p>
		<p class="texte">
			<form name="input" action="index.php?aff=players" method="post">
			<input type="hidden" name="Login" size="15" value="'.$_POST['PlayerLogin'].'">
			'.$lang['Message'].' : <input type="text" name="ChatText" size="40">
			<input type="submit" name="action" value="'.$lang_b['ChatSendToLogin'][0].'" title="'.$lang_b['ChatSendToLogin'][1].'">
			</form>';
	echo '</p>
		<p class="bas">[<a href="index.php?aff=players">'.$lang['Abord'].'</a>]</p></div>';
	
	echo '<div class="rub">
		<p class="titre">'.$lang['Players'].'</p>';

		if (!$client->query('GetPlayerList', 50, 0)) {
		   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
		}
		else {	
			$compteur = 0;
			$PlayerList = $client->getResponse();
			echo '
			<p class="texte">
			<table style="text-align: center">
				<tr class="legende">
					<td>'.$lang['Login'].'</td>
					<td>'.$lang['NickName'].'</td>
					<td>'.$lang['TeamId'].'</td>
					<td>'.$lang['Spectator'].'</td>
					<td>'.$lang['IsInOfficialMode'].'</td>
					<td>'.$lang['LadderRanking'].'</td>
					<td></td>
				</tr>';
			if(count($PlayerList) == 0) echo '<td>-</td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td>';
			else {
				foreach ($PlayerList as $player) {
					$compteur++;
					$PlayerLogin = $player['Login'];
					$PlayerName = Couleur($player['NickName']);
					$PlayerRanking = $player['LadderRanking'];
					//$PlayerAvatar = $player['Avatar'];
					$PlayerIsSpectator = ($player['IsSpectator']!=0) ? "Spectator" : "Player";
					$PlayerIsInOfficialMode = ($player['IsInOfficialMode']!=0) ? "Official" : "Not Official";

					$PlayerTeamId = $player['TeamId'];
					if( $PlayerTeamId == -1) $PlayerTeam = $lang['No_Team'];
					elseif( $PlayerTeamId == 0) $PlayerTeam = $lang['Blue_Team'];
					else $PlayerTeam = $lang['Red_Team'];

					echo "
					<tr class=\"".class_ligne($compteur)."\"s>
						<td style=\"text-align: left\"><a href=\"?aff=players&login=".urlencode($PlayerLogin)."\">$PlayerLogin</a></td>
						<td>$PlayerName</td>
						<td>$PlayerTeam</td>
						<td>$PlayerIsSpectator</td>
						<td>$PlayerIsInOfficialMode</td>
						<td>$PlayerRanking</td>
						<td>";
					echo '		<form style="display:inline" action="index.php?aff=players" method="post">
								<input type="hidden" name="PlayerLogin" value="'.$PlayerLogin.'">
								<input type="submit" name="action" value="'.$lang_b['Kick'][0].'" title="'.$lang_b['Kick'][1].'">
								<input type="submit" name="action" value="'.$lang_b['Ban'][0].'" title="'.$lang_b['Ban'][1].'">
							</form>
							<form style="display:inline" action="index.php?aff=players&aff_chat_player" method="post">
								<input type="hidden" name="PlayerLogin" value="'.$PlayerLogin.'">
								<input type="submit" value="'.$lang_b['Message'][0].'" title="'.$lang_b['Message'][1].'">
							</form>
						</td>
					</tr>';
				}
			}
			echo "</table><b>Total : $compteur {$lang['Players']}</b>
			</p>
			</div>";
		}
}

function player($login) {
	global $client, $lang, $server_type;

	if (!$client->query('GetPlayerInfo', $login)) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	else
	{
		$GetPlayerInfo = $client->getResponse();
		$NickName = Couleur($GetPlayerInfo['NickName'])." - ".$GetPlayerInfo['NickName'];
		$IPAddress = $GetPlayerInfo['IPAddress'];
		$ConnectionType = $GetPlayerInfo['ConnectionType'];
		$PlayerId = $GetPlayerInfo['PlayerId'];
		$IsSpectator = ($GetPlayerInfo['IsSpectator']!=0) ? "Spectator" : "Player";
		$IsInOfficialMode = ($GetPlayerInfo['IsInOfficialMode']!=0) ? "Official" : "Not Official";
		$HasJoinMatch = ($GetPlayerInfo['HasJoinMatch']==1) ? "Oui" : "Non";
		$Avatar = $GetPlayerInfo['Avatar'];
		$LadderStats = $GetPlayerInfo['LadderStats'];
		//eregi_replace("([a-zA-Z0-9]*[\\])*(\.dds)?","",$Avatar['FileName'])
		
		$avatar_flag = (file_exists("icons/flags/".substr($Avatar['FileName'], -7, -4).".png")) ? True : False;
		
		
		echo "<div class=\"rub\">
			<p class=\"titre\">".$lang['Infos_Player']." : $login</p>
			<p class=\"texte\">";
			if($avatar_flag) $style = 'background: url(\'icons/flags/'.substr($Avatar['FileName'], -7, -4).'.png\') no-repeat right top;';
		echo "	<table align=\"center\" class=\"player\" style=\"$style\">
				<tr>
					<td>".$lang['Login']."</td>
					<td>$login</td>
				</tr>
				<tr>
					<td>".$lang['NickName']."</td>
					<td>$NickName</td>
				</tr>
				<tr>
					<td>".$lang['IPAddress']."</td>
					<td>$IPAddress</td>
				</tr>
				<tr>
					<td>".$lang['ConnectionType']."</td>
					<td>$ConnectionType</td>
				</tr>
				<tr>
					<td>".$lang['PlayerId']."</td>
					<td>$PlayerId</td>
				</tr>
				<tr>
					<td>".$lang['Spectator']."</td>
					<td>$IsSpectator</td>
				</tr>
				<tr>
					<td>".$lang['IsInOfficialMode']."</td>
					<td>$IsInOfficialMode</td>
				</tr>
				<tr>
					<td>".$lang['HasJoinMatch']."</td>
					<td>$HasJoinMatch</td>
				</tr>
				<tr>
					<td>".$lang['Avatar']."</td>
					<td>".$Avatar['FileName']."</td> 
				</tr>
				<tr>
					<td>".$lang['LadderRanking']."</td>
					<td>{$LadderStats['Ranking']}</td>
				</tr>
				<tr>
					<td>".$lang['Score']."</td>
					<td>".number_format($LadderStats['Score'], 2)."</td>
				</tr>
				<tr>
					<td>".$lang['LastMatchScore']."</td>
					<td>".number_format($LadderStats['LastMatchScore'], 5)."</td>
				</tr>
				<tr>
					<td>".$lang['NbrMatchWins']."</td>
					<td>{$LadderStats['NbrMatchWins']}</td>
				</tr>
				<tr>
					<td>".$lang['NbrMatchDraws']."</td>
					<td>{$LadderStats['NbrMatchDraws']}</td>
				</tr>
				<tr>
					<td>".$lang['NbrMatchLosses']."</td>
					<td>{$LadderStats['NbrMatchLosses']}</td>
				</tr>
				<tr>
					<td>".$lang['NbrTotalPlayers']."</td>
					<td>{$LadderStats['NbrTotalPlayers']}</td>
				</tr>
				<tr>
					<td>".$lang['TeamName']."</td>
					<td>{$LadderStats['TeamName']}</td>
				</tr>
				<tr>
					<td>".$lang['TeamRanking']."</td>
					<td>{$LadderStats['TeamRanking']}</td>
				</tr>
				<tr>
					<td>".$lang['NbrTotalTeams']."</td>
					<td>{$LadderStats['NbrTotalTeams']}</td>
				</tr>
			</table>
		</p>
		</div>
		";
	}
}

function chat() {
	global $client, $lang, $lang_b;
	echo '<div class="rub">
			<p class="titre">'.$lang['Chat'].'</p>
			<div class="texte" style="text-align: center">';
		// vérifie si on peux avoir les dernières lignes de chat et affiche l'erreur sinon
		if (!$client->query('GetChatLines')) {
		   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
		}
		else
		{	//fait affiche le formulaire de rentrée du pseudo si pas de pseudo enregistré dans la session courante
			if(!isset($_SESSION['pseudo'])) {
				echo '<table class="none" align="center">
					<tr>
						<td>
							<form name="input" action="index.php?aff=chat&pseudo=1" method="post">
								'.$lang['NickName'].' : <input type="text" name="pseudo" size="20"><br />
								<input type="submit" value="'.$lang_b['Save'][0].'" title="'.$lang_b['Save'][1].'">
							</form>
						</td><td style="padding-left:5em"></td>';
				}
			else { //sinon affiche de quoi le supprimer (le pseudo)
				echo '<table class="none" align="center">
					<tr>
						<td>
							<form name="input" action="index.php?aff=chat&pseudo=2" method="post">';
							if(!empty($_SESSION['pseudo'])) echo $lang['NickName'].' : '.$_SESSION['pseudo'];
							echo '<br /><input type="submit" name="pseudo" value="'.$lang['Clear_NickName'].'" title="'.$lang_b['Clear_NickName'][1].'">
							</form>
						</td><td style="padding-left:5em"></td>';
			}
			echo '<td>';
			if($_SESSION['No_Fast'] == 1) {
				echo '<form name="aff_fast" action="index.php?aff=chat&aff_fast" method="POST">
						<input name="Aff_Fast" value="'.$lang_b['Aff_Fast'][0].'" title="'.$lang_b['Aff_Fast'][1].'" type="submit">
					</form>';
			}
			else {
				echo '<form name="no_fast" action="index.php?aff=chat&no_fast" method="POST">
						<input name="No_Fast" value="'.$lang_b['No_Fast'][0].'" title="'.$lang_b['No_Fast'][1].'" type="submit">
					</form>';
			}
			echo '</td>';
		echo '<td>
				<form name="chat" id="chat">
					<input name="charger" value="'.$lang['Refresh'].'" onClick="chargeFichier();" type="button"><br />
					<input name="auto" type="checkbox" onClick="automatique();" checked> '.$lang['AutoRefresh'].'
				</form>
			</td>
		</tr>
	</table>';
			
			echo '<div id="zoneChat"><p style="color:red; font-weight:bold; margin: 12em auto 12em auto; padding:none">'.$lang['PleaseWait'].'</p></div>';
			
			// envoi d'un message général  (l'ajout du pseudo est gérée lors de l'envoi de la commande au serveur)
			echo '<form name="ChatTextForm" method="POST" onSubmit="return false">
			'.$lang['Message'].' : <input type="text" name="ChatText" size="70">';
			echo '<input type="button" value="'.$lang_b['ChatSendServerMessage'][0].'" title="'.$lang_b['ChatSendServerMessage'][1].'" onClick="sendData(\'ChatText\', document.ChatTextForm.ChatText.value, \'chat.php\', \'POST\');">';
			echo '<br /><input style="border: none; color:green; background:none" type="text" name="etat" size="20" disabled>
			</form>';
			//<hr style="width:50%; margin : 1em auto 1em auto" />';
			//<input type="submit" name="action" value="'.$lang_b['ChatSend'][0].'ChatSend">
			
			// ChatSendToLogin
			echo '<form name="input" action="index.php?aff=chat" method="post">
			'.$lang['Login'].' : <input type="text" name="Login" size="15">
			'.$lang['Message'].' : <input type="text" name="ChatText" size="70">
			<input type="submit" name="action" value="'.$lang_b['ChatSendToLogin'][0].'" title="'.$lang_b['ChatSendToLogin'][1].'">
			</form>';
		}
			echo('
		</div>
			</div>');
			
	chatcommand();

//ChatSendToId
//boolean ChatSendToId(string, int)
//Send a text message to with the specified PlayerId. Only available to Admin. -> a faire ?
}

function question() {
	global $client, $lang, $lang_b;
	
	echo '<div class="rub">
		<p class="titre">'.$lang['Questions'].'</p>
		<p class="texte">
		<form name="input" action="index.php?aff=question" method="post" style="text-align: center">
		<table align="center">
			<tr>
				<td>'.$lang['Message'].'</td>
				<td><input type="text" name="Message" size="70" /></td>
			</tr>
			<tr>
				<td>'.$lang['Button_1'].'</td>
				<td><input type="text" name="Button1" size="70" /></td>
			</tr>
			<tr>
				<td>'.$lang['Button_2'].'</td>
				<td><input type="text" name="Button2" size="70" /></td>
			</tr>
			<tr>
				<td>'.$lang['TimeOut'].'</td>
				<td><input type="text" name="TimeOut" size="70" /></td>
			</tr>
			<tr>
				<td>'.$lang['Login'].'</td>
				<td><input type="text" name="Login" size="70" /></td>
			</tr>
		</table>
			<input type="submit" name="action" value="'.$lang_b['SendDisplayServerMessage'][0].'" title="'.$lang_b['SendDisplayServerMessage'][1].'">
			<input type="submit" name="action" value="'.$lang_b['SendDisplayServerMessageToLogin'][0].'" title="'.$lang_b['SendDisplayServerMessageToLogin'][1].'">
			<input type="submit" name="action" value="'.$lang_b['SendHideServerMessage'][0].'" title="'.$lang_b['SendHideServerMessage'][1].'">
			<input type="submit" name="action" value="'.$lang_b['SendHideServerMessageToLogin'][0].'" title="'.$lang_b['SendHideServerMessageToLogin'][1].'">
		</form></p>
		</div>';
		
		if (!$client->query('EnableCallbacks', true)) {
			trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
		}
		flush();

		if(!empty($_POST['Message'])) {
			$timeout = (!empty($_POST['TimeOut']) OR $_POST['TimeOut'] < 28000) ? $_POST['TimeOut'] : 25000;
			$time = $timeout+2000;
			if($timeout >= 25000) $warning = '<i style="font-size: 11px; color: red">(Seules les réponses antérieures à 25 secondes seront affichées.)<i>';
			echo '<div class="rub"><p class="titre">'.$lang['Answers'].' - '.$warning.'</p><p class="texte">';
			
			echo '<table><tr class="legende"><td>'.$lang['Login'].'</td><td>'.$lang['PlayerId'].'</td><td>'.$lang['Result'].'</td></tr>';
			while($time > 0) {
				$client->readCB(1);
				$calls = $client->getCBResponses();
				if (!empty($calls)) {
					foreach($calls as $call) {
						if($call[0] == 'TrackMania.PlayerServerMessageAnswer') {
							echo "<tr><td>{$call[1][1]}</td><td>{$call[1][0]}</td><td>";
							switch($call[1][2]) {
								case 0:
									echo "<i>timeout<i>";
								break;
								case 1:
									echo $_POST['Button1'];
								break;
								case 2:
									echo $_POST['Button2'];
								break;
							}
							echo "</td></tr>";
						}
					}	
				}
				flush();
				$time = $time - 1000;
			}
			echo '</table></p></div>';		
		}
}

function ranking() {
	global $client, $lang, $lang_b;
	
	echo '<div class="rub">
			<p class="titre">'.$lang['Ranking'].'</p>
			<p class="texte">';

		if (!$client->query('GetCurrentRanking', 50, 0)) {
		   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
		}
		else {
			$compteur = 0;
			$CurrentRanking = $client->getResponse();
			echo '<table style="text-align: center">
				<tr class="legende">
					<td>'.$lang['Login'].'</td>
					<td>'.$lang['NickName'].'</td>
					<td>'.$lang['Ranking'].'</td>
					<td>'.$lang['Best_Time'].'</td>
					<td>'.$lang['Score'].'</td>
					<td>'.$lang['NbrLaps'].'</td>
					<td>'.$lang['LadderScore'].'</td>
				</tr>
			';
			if(count($CurrentRanking) == 0) echo '<td>-</td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td>';
			else {
				foreach ($CurrentRanking as $Ranking) {
					$PlayerLogin = $Ranking['Login'];
					$PlayerName = Couleur($Ranking['NickName']);
					$PlayerRank = $Ranking['Rank'];
					$PlayerBestTime = MwTimeToString($Ranking['BestTime']);
					$PlayerScore = $Ranking['Score'];
					$PlayerNbrLaps = $Ranking['NbrLapsFinished'];
					$PlayerLadderScore = $Ranking['LadderScore'];
					
				echo "
					<tr class=\"".class_ligne($compteur)."\">
						<td style=\"text-align: left\"><a href=\"index.php?aff=players&login=".urlencode($PlayerLogin)."\">$PlayerLogin</a></td>
						<td>$PlayerName</td>
						<td>$PlayerRank</td>
						<td>$PlayerBestTime</td>
						<td>$PlayerScore</td>
						<td>$PlayerNbrLaps</td>
						<td>$PlayerLadderScore</td>
					</tr>";
					$compteur++;
				}
			}
			echo "</table>
			</p>
		</div>";
		}
}

function server_options() {
	global $client, $lang, $lang_b;
	echo '<div class="rub">
			<p class="titre">'.$lang['Server_options'].'</p>
			<p class="texte">';

	if (!$client->query('GetServerOptions')) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	else {
		$ServerOptions = $client->getResponse();
		$repGetServerName = $ServerOptions['Name'];
		$repServerComment = $ServerOptions['Comment'];
		$repServerPassword = $ServerOptions['Password'];
		$repPasswordForSpectator = $ServerOptions['PasswordForSpectator'];
		$repCurrentMaxPlayer = $ServerOptions['CurrentMaxPlayers'];
		$repNextMaxPlayer = $ServerOptions['NextMaxPlayers'];
		$repCurrentMaxSpectator = $ServerOptions['CurrentMaxSpectators'];
		$repNextMaxSpectator = $ServerOptions['NextMaxSpectators'];
		$repP2PUpload = ($ServerOptions['IsP2PUpload']!=0) ? "checked" : " ";
		$repP2PDownload = ($ServerOptions['IsP2PDownload']!=0) ? "checked" : " ";
		$repCurrentLadderMode = $ServerOptions['CurrentLadderMode'];
		$repNextLadderMode = $ServerOptions['NextLadderMode'];
		$repCurrentVehicleNetQuality = $ServerOptions['CurrentVehicleNetQuality'];
		$repNextVehicleNetQuality = $ServerOptions['NextVehicleNetQuality'];
		$repCurrentCallVoteTimeOut = $ServerOptions['CurrentCallVoteTimeOut'];
		$repNextCallVoteTimeOut = $ServerOptions['NextCallVoteTimeOut'];
		$repCallVoteRatio = $ServerOptions['CallVoteRatio'];
		$repAllowChallengeDownload = ($ServerOptions['AllowChallengeDownload']!=0) ? "checked" : " ";
	
	//echo $repAllowChallengeDownload."\n";
	
		switch($repCurrentLadderMode) {
			case 0:
				$CurrentLadderMode = $lang['Inactive'];
			break;
			case 1;
				$CurrentLadderMode = $lang['Normal'];
			break;
			case 2:
				$CurrentLadderMode = $lang['Forced'];
			break;
			default:
				$CurrentLadderMode = $lang['Undefined'];
			break;
		}

		switch($repNextLadderMode) {
			case 0:
				$NextLadderModeInactive = "selected";
				$NextLadderModeNormal = "";
				$NextLadderModeForced = "";
			break;
			case 2:
				$NextLadderModeInactive = "";
				$NextLadderModeNormal = "";
				$NextLadderModeForced = "selected";
			break;
			default:
				$NextLadderModeInactive = "";
				$NextLadderModeNormal = "selected";
				$NextLadderModeForced = "";
			break;
		}
		
		switch($repCurrentVehicleNetQuality) {
			case 0:
				$CurrentVehicleNetQuality = $lang['Fast'];
			break;
			case 1;
				$CurrentVehicleNetQuality = $lang['High'];
			break;
			default:
				$CurrentVehicleNetQuality = $lang['Undefined'];
			break;
		}
		
		switch($repNextVehicleNetQuality) {
			case 1;
				$NextVehicleNetQualityFast = "";
				$NextVehicleNetQualityHigh = "selected";
			break;
			default:
				$NextVehicleNetQualityFast = "selected";
				$NextVehicleNetQualityHigh = "";
			break;
		}

	
	echo '<form name="input" action="index.php?aff=server_options" method="post">
			<table align="center" class="server_options">
				<tr>
					<td>'.$lang['Name'].'</td>
					<td><input type="text" name="ServerName" size="30" maxlength="25" value="'.$repGetServerName.'"/> ('.texte_chat($repGetServerName).')</td>
				</tr>
				<tr>
					<td>'.$lang['Comment'].'</td>
					<td><textarea name="ServerComment" cols="60" rows="3">'.$repServerComment.'</textarea></td>
				</tr>
				<tr>
					<td>'.$lang['Password'].'</td>
					<td>
						<table class="none">
							<tr>
								<td>'.$lang['Players'].'</td>
								<td><input type="text" name="ServerPassword" size=30 value="'.$repServerPassword.'"/></td>
								<td>'.$lang['Spectator'].'</td>
								<td><input type="text" name="SpectatorPassword" size=30 value="'.$repPasswordForSpectator.'"/></td>
							</tr>
						</table>
					</td>
				<tr>
					<td>'.$lang['MaxPlayer'].'</td>
					<td>
						<table class="none" align="center">
							<tr>
								<td style="width: 30%">'.$repCurrentMaxPlayer.'</td>
								<td style="font-weight: bold">'.$lang['Next_Value'].'</td>
								<td style="width: 30%"><input type="text" name="NextMaxPlayers" size="4" style="text-align:center;" value="'.$repNextMaxPlayer.'"/></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>'.$lang['MaxSpectator'].'</td>
					<td>
						<table class="none">
							<tr>
								<td style="width: 30%">'.$repCurrentMaxSpectator.'</td>
								<td style="font-weight: bold">'.$lang['Next_Value'].'</td>
								<td style="width: 30%"><input type="text" name="NextMaxSpectators" size="4" style="text-align:center;" value="'.$repNextMaxSpectator.'"/> </td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>P2P</td>
					<td>
						<table class="none">
							<tr>
								<td><input type="checkbox" name="IsP2PUpload" '.$repP2PUpload.'/> '.$lang['P2PUpload'].'</td>
								<td></td>
								<td><input type="checkbox" name="IsP2PDownload" '.$repP2PDownload.'/> '.$lang['P2PDownload'].'</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>'.$lang['LadderMode'].'</td>
					<td>
						<table class="none">
							<tr>
								<td style="width: 30%">'.$CurrentLadderMode.'</td>
								<td style="font-weight: bold">'.$lang['Next_Value'].'</td>
								<td style="width: 30%">
									<select name="NextLadderMode" >
										<OPTION value="0" '.$NextLadderModeInactive.'> '.$lang['Inactive'].' </OPTION>
										<OPTION value="1" '.$NextLadderModeNormal.'> '.$lang['Normal'].' </OPTION>
										<OPTION value="2" '.$NextLadderModeForced.'> '.$lang['Forced'].' </OPTION>
									</select>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>'.$lang['VehicleNetQuality'].'</td>
					<td>
						<table class="none" align="center">
							<tr>
								<td style="width: 30%">'.$CurrentVehicleNetQuality.'</td>
								<td style="font-weight: bold">'.$lang['Next_Value'].'</td>
								<td style="width: 30%">
									<SELECT name="NextVehicleNetQuality" >
										<OPTION value="0" '.$NextVehicleNetQualityFast.'> '.$lang['Fast'].' </OPTION>
										<OPTION value="1" '.$NextVehicleNetQualityHigh.'> '.$lang['High'].' </OPTION>
									</SELECT>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>'.$lang['CallVoteTimeOut'].'</td>
					<td>
						<table class="none">
							<tr>
								<td style="width: 30%">'.$repCurrentCallVoteTimeOut.'</td>
								<td style="font-weight: bold">'.$lang['Next_Value'].'</td>
								<td style="width: 30%"><input type="text" style="text-align: center" name="NextCallVoteTimeOut" size="8" value="'.$repNextCallVoteTimeOut.'"/></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>'.$lang['CallVoteRatio'].'</td>
					<td><input type="text" name="CallVoteRatio" size=10 value="'.$repCallVoteRatio.'"/> </td>
				</tr>
				<tr>
					<td>'.$lang['AllowChallengeDownload'].'</td>
					<td><input type="checkbox" name="AllowChallengeDownload" '.$repAllowChallengeDownload.'/> </td>
				</tr>
				<tr>
					<td colspan="2" style="text-align: center"><input type="submit" name="action" value="'.$lang_b['SetServerOptions'][0].'" title="'.$lang_b['SetServerOptions'][1].'"></td>
				</tr>
			</table>
			
			</form>
			<hr style="width:50%; margin : 1em auto 1em auto" />
	';
	}
	
	if( $_SESSION['authLogin']=="SuperAdmin" ) {
		echo '
		<form name="input" action="index.php" method="post">
			<table align="center" class="none">
				<tr>
					<td>'.$lang['Set_new_Password'].'</td>
					<td><input type="password" name="newPassword" size="30" value="" /></td>
					<td>'.$lang['for'].'</td>
					<td>
						<select name="newLogin">
							<option value="SuperAdmin"> SuperAdmin </option>
							<option value="Admin"> Admin </option>
							<option value="User"> User </option>
						</select>
					</td>
					<td>
						<input type="submit" name="action" value="'.$lang_b['ChangeAuthPassword'][0].'" title="'.$lang_b['ChangeAuthPassword'][1].'">
					</td>
				</tr>
			</table>
		</form>
		</p>
	</div>';
	}
}

function guest_ban_list() {
	global $client, $lang, $lang_b;
	
echo '<div class="rub">
		<p class="titre">'.$lang['GuestList'].'</p>
		<p class="texte">';

	if (!$client->query('GetGuestList', 50, 0)) trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	else {
		$GuestList = $client->getResponse();
		$i = 0;
		$max = count($GuestList);
		echo '<table style="padding:0" align="center"><tr>';
		foreach ($GuestList as $player) {
			$PlayerLogin=$player['Login'];
			$i++;
			
		echo "<td style=\"text-align: right\">$PlayerLogin</td>
				<td>
					<form action=\"index.php?aff=guest_ban_list\" method=\"post\">
						<input type=\"hidden\" name=\"PlayerLogin\" value=\"$PlayerLogin\">
						<input type=\"submit\" name=\"action\" value=\"{$lang_b['RemoveGuest'][0]}\" title=\"{$lang_b['RemoveGuest'][1]}\">
					</form>
				</td>\n";
				if($i == $max AND !is_int($max/2)) echo "<td></td>\n<td></td>\n";
			if(is_int($i/2)) {
				echo "</tr>";
				if($i != $max)  echo "<tr>\n";
			}
			
		}
		echo '</table><br />';
		
		echo '<form style="text-align: center" name="input" action="index.php?aff=guest_ban_list" method="post">
				'.$lang['Login'].' : <input type="text" name="PlayerLogin" size="40"/>
				<input type="submit" name="action" value="'.$lang_b['AddGuest'][0].'" title="'.$lang_b['AddGuest'][1].'">
			</form>';

		echo '<form style="text-align: center" name="input" action="index.php?aff=guest_ban_list" method="post">
				'.$lang['File'].' : <input type="text" name="GuestListFileName" size="40" /><br />
				<input type="submit" name="action" value="'.$lang_b['LoadGuestList'][0].'" title="'.$lang_b['LoadGuestList'][1].'">
				<input type="submit" name="action" value="'.$lang_b['SaveGuestList'][0].'" title="'.$lang_b['SaveGuestList'][1].'">
			</form>';
	}

	echo '</p>
	</div>';
	
	echo '<div class="rub">
			<p class="titre">'.$lang['BlackList'].'</p>
			<p class="texte">';

	if (!$client->query('GetBlackList', 50, 0)) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	else {
		$BlackList = $client->getResponse();
		echo '<table style="padding:0" align="center"><tr>';
		$i = 0;
		$max = count($BlackList);
		foreach ($BlackList as $player) {
			$PlayerLogin=$player['Login'];
			$i++;
			echo "<td style=\"text-align: right\">$PlayerLogin</td>
				<td>
					<form action=\"index.php?aff=guest_ban_list\" method=\"post\">
						<input type=\"hidden\" name=\"PlayerLogin\" value=\"$PlayerLogin\">
						<input type=\"submit\" name=\"action\" value=\"{$lang_b['UnBlackList'][0]}\" title=\"{$lang_b['UnBlackList'][1]}\">
					</form>
				</td>";
			if($i == $max AND !is_int($max/2)) echo "<td></td>\n<td></td>\n";
			if(is_int($i/2)) {
				echo "</tr>";
				if($i != $max)  echo "<tr>\n";
			}
		}
		echo '</table><br />';

		echo '<form style="text-align: center" name="input" action="index.php?aff=guest_ban_list" method="post">
				'.$lang['Login'].' : <input type="text" name="PlayerLogin" size="40">
				<input type="submit" name="action" value="'.$lang_b['BlackList'][0].'" title="'.$lang_b['BlackList'][1].'">
			</form>';

		echo '<form style="text-align: center" name="input" action="index.php?aff=guest_ban_list" method="post">
			'.$lang['File'].' :<input type="text" name="BlackListFileName" size="40"/><BR>
			<input type="submit" name="action" value="'.$lang_b['LoadBlackList'][0].'" title="'.$lang_b['LoadBlackList'][1].'">
			<input type="submit" name="action" value="'.$lang_b['SaveBlackList'][0].'" title="'.$lang_b['SaveBlackList'][1].'">
		</form>';

	}
	echo '</p>
	</div>
	<div class="rub">
		<p class="titre">'.$lang['BanList'].'</p>
		<p class="texte">';

	if (!$client->query('GetBanList', 50, 0)) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	else {
		$BanList = $client->getResponse();
		
		if(count($BanList) == 0) echo $lang['NoBan'];
		else {

			echo '<table style="text-align: center">
			<tr class="legende">
				<td>Login</td>
				<td>ClientName</td>
				<td>IPAddress:Port</td>
				<td></td>
			</tr>';
			foreach ($BanList as $player) {
				$PlayerLogin=$player['Login'];
				$PlayerClientName=$player['ClientName'];
				$PlayerIPAddress=$player['IPAddress'];	
				echo "<tr>
						<td>$PlayerLogin</td>
						<td>$PlayerClientName</td>
						<td>$PlayerIPAddress</td>
						<td>
							<form action=\"index.php?aff=guest_ban_list\" method=\"post\">
								<input type=\"hidden\" name=\"PlayerLogin\" value=\"$PlayerLogin\">
								<input type=\"submit\" name=\"action\" value=\"{$lang_b['UnBan'][0]}\" title=\"{$lang_b['UnBan'][1]}\">
							</form>
						</td>
					</tr>";
				}
			echo "</table>";
			echo '<form style="text-align: center" action="index.php?aff=guest_ban_list" method="post">
			<input type="submit" name="action" value="'.$lang_b['CleanBanList'][0].'" title="'.$lang_b['CleanBanList'][1].'" />
			</form>';
		}
	}
	echo '</p>
	</div>';

}

function challenges() {
	global $client, $lang, $lang_b, $Directory;

if (!$client->query('GetChallengeList', 200, 0)) trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
else {
	$compteur = 0;
	$ChallengeList = $client->getResponse();
	
	if (!$client->query('GetCurrentChallengeIndex')) trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	else $CurrentChallengeIndex = $client->getResponse() + 1;
	
	echo '<div class="rub" style="margin:auto 0; margin-bottom: 1em; width:100%">
		<p class="titre">'.$lang['Challenges'].'</p>
		<div class="texte">
		<form action="index.php?aff=challenges" method="post" style="text-align: right">
		<table style="text-align: center">
			<tr class="legende">
				<td>'.$lang['File_Name'].'</td>
				<td>'.$lang['Environnement'].'</td>
				<td>'.$lang['Mood'].'</td>
				<td>'.$lang['GoldTime'].'</td>
				<!--<td></td>-->
				<td style="width: 30px;">'.$lang['Gestion'].'</td>
			</tr>
	';
	foreach ($ChallengeList as $challenge) {
		$compteur++;
		if($compteur == $CurrentChallengeIndex) $class_ligne = "ligne_current";
		else $class_ligne = class_ligne($compteur);
		//$ChallengeUId = $challenge['UId'];
		$FileName = $challenge['FileName'];
		$FileNameUrl = urlencode($FileName);
		$Environnement = $challenge['Environnement'];
		$GoldTime = MwTimeToString($challenge['GoldTime']);
		$CopperPrice = $challenge['CopperPrice'];
		$Mood = $challenge['Mood'];
		echo '<tr class="'.$class_ligne.'">
				<td style="text-align: left"><b><a href="?aff=challenges&filename='.urlencode($FileName).'" >'.eregi_replace("([^\\]*[\\])*(\.Challenge|\.Gbx)?","",Couleur($FileName)).'</a></b><br />'.$FileName.'</td>
				<td>'.$Environnement.'</td>
				<td>'.$Mood.'</td>
				<td>'.$GoldTime.'</td>';
				/*<td>
					<form action="index.php?aff=challenges" method="post">
						<input type="hidden" name="ChallengeFileName" value="'.$FileName.'">
						<input type="submit" name="action" value="'.$lang_b['RemoveChallenge'][0].'" title="'.$lang_b['RemoveChallenge'][1].'">
					</form>
					<form action="index.php?aff=challenges" method="post">
						<input type="hidden" name="ChallengeFileName" value="'.$FileName.'">
						<input type="submit" name="action" value="'.$lang_b['ChooseNextChallenge'][0].'" title="'.$lang_b['ChooseNextChallenge'][1].'">
					</form>
				</td>*/
				echo '<td>
					<input type="checkbox" name="fichiers[]" value="'.$FileName.'">
				</td>
			</tr>';
	}
	echo '</table><input type="submit" name="action" value="'.$lang_b['ChooseNextChallengeList'][0].'" title="'.$lang_b['ChooseNextChallengeList'][1].'">
	<input type="submit" name="action" value="'.$lang_b['RemoveChallengeList'][0].'" title="'.$lang_b['RemoveChallengeList'][1].'">
	</form>
	</div>
	</div>';	
}


echo '<div class="rub">
	<p class="titre">'.$lang['Management'].'</p>
	<div class="texte">';
	
echo '<p class="legende">'.$lang['Add_Challenge'].'</p>
<form name="input" action="index.php?aff=challenges" method="post" style="text-align: center">
	'.GetDirectory('GetTracksDirectory').' <input type="text" name="ChallengeFileName" size="50" />
	<input type="submit" name="action" value="'.$lang_b['AddChallenge'][0].'" title="'.$lang_b['AddChallenge'][1].'" />
	<input type="submit" name="action" value="'.$lang_b['InsertChallenge'][0].'" title="'.$lang_b['InsertChallenge'][1].'" />
</form>';

echo '<p class="legende" style="border-top: 1px solid silver; margin-top: 10px">'.$lang['ListChallenges'].'</p>
<form name="input" action="index.php?aff=challenges" method="post" style="text-align: center">
	'.GetDirectory('GetTracksDirectory');
if( get_server_type() == 'TMU') {
	echo 'MatchSettings/';
}
echo ' <input type="text" name="MatchSettingsFileName" size="50"/><BR>
	<input type="submit" name="action" value="'.$lang_b['LoadMatchSettings'][0].'" title="'.$lang_b['LoadMatchSettings'][1].'" />
	<input type="submit" name="action" value="'.$lang_b['SaveMatchSettings'][0].'" title="'.$lang_b['SaveMatchSettings'][1].'" />
	<input type="submit" name="action" value="'.$lang_b['AppendPlaylistFromMatchSettings'][0].'" title="'.$lang_b['AppendPlaylistFromMatchSettings'][1].'" />
</form>';

echo '</div></div>';


if(TM_AND_WEB) {
	if (!$client->query('GetTracksDirectory')) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	else {
		$GameDataDirectory = $client->getResponse();
		$getFile = browse($GameDataDirectory.urldecode($_GET['dossier']),"Gbx");
		$countFile = count($getFile);
		$getDossier = browse_d($GameDataDirectory.urldecode($_GET['dossier']));
	    $countDossier = count($getDossier);
		echo '<a name="listing"></a><div class="rub">
			<p class="titre">'.$lang['Challenges_listing'].'</p>
			<div class="texte">
			<p class="legende">'.$GameDataDirectory.StripS(urldecode($_GET['dossier'])).'</p><br />';
				echo '<u>'.$lang['Folders'].'</u><br />';
				if ($countDossier != 0)            
					{
						foreach ($getDossier as $myDossier) echo '<span style="padding-left: 3em"><a href="?aff=challenges&dossier='.urlencode(StripS($_GET['dossier']).$myDossier.'/').'#listing">'.$myDossier.'</a></span>';
					}
				else echo $lang['no_folders_found']; 
				echo '<br /><br /><u>'.$lang['Files'].'</u><br />';
				if ($countFile != 0) {
						echo '<form action="?aff=challenges" method="POST" style="text-align: center">';
						echo '<table><tr>';
						$i = 0;
						$max = count($getFile);
						foreach ($getFile as $myFile) {
							$i++;
							echo '<td><input type="checkbox" name="fichiers[]" value="'.StripS(urldecode($_GET['dossier'])).$myFile.'" /></td>';
							echo "<td>".$myFile."</td>\n";
							if($i==$max AND !is_int($i/2)) echo "<td></td><td></td>\n";
							if(is_int($i/2)) echo "</tr>\n";
							if(is_int($i/2) AND $i != $max) echo "<tr>\n";
						}
						echo '</table>';
						echo '<input type="submit" name="action" value="'.$lang_b['AddChallengeList'][0].'" title="'.$lang_b['AddChallengeList'][1].'" />
							<input type="submit" name="action" value="'.$lang_b['InsertChallengeList'][0].'" title="'.$lang_b['InsertChallengeList'][1].'" />
						</form>';
					}
				else echo $lang['no_files_found']."<br />"; 
		echo '</div>
			</div>';
	}
} else echo '<center><i>'.$lang['no_listing'].'</i><center>';

}

function challenge($filename) {
	global $client, $lang;

	if (!$client->query('GetChallengeInfo', $filename)) {
		echo $filename;
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	else {
		$GetChallengeInfo = $client->getResponse();
		$Name = Couleur($GetChallengeInfo['Name']);
		$UId = $GetChallengeInfo['UId'];
		$Author = $GetChallengeInfo['Author'];
		$Environnement = $GetChallengeInfo['Environnement'];
		$Mood = $GetChallengeInfo['Mood'];
		$BronzeTime = MwTimeToString($GetChallengeInfo['BronzeTime']);
		$SilverTime = MwTimeToString($GetChallengeInfo['SilverTime']);
		$GoldTime = MwTimeToString($GetChallengeInfo['GoldTime']);
		$AuthorTime = MwTimeToString($GetChallengeInfo['AuthorTime']);
		$CopperPrice = $GetChallengeInfo['CopperPrice'];
		$LapRace = $GetChallengeInfo['LapRace'];
			
		echo "<div class=\"rub\">
			<p class=\"titre\">".$lang['Infos_Challenge']." : $Name</p>
			<p class=\"texte\">
			<table align=\"center\" class=\"player\">
				<tr>
					<td>".$lang['Name']."</td>
					<td>$filename</td>
				</tr>
				<tr>
					<td>".$lang['UId']."</td>
					<td>$UId</td>
				</tr>
				<tr>
					<td>".$lang['Author']."</td>
					<td>$Author</td>
				</tr>
				<tr>
					<td>".$lang['Environnement']."</td>
					<td>$Environnement</td>
				</tr>
				<tr>
					<td>".$lang['Mood']."</td>
					<td>$Mood</td>
				</tr>
				<tr>
					<td>".$lang['BronzeTime']."</td>
					<td>$BronzeTime</td>
				</tr>
				<tr>
					<td>".$lang['SilverTime']."</td>
					<td>$SilverTime</td>
				</tr>
				<tr>
					<td>".$lang['GoldTime']."</td>
					<td>$GoldTime</td>
				</tr>
				<tr>
					<td>".$lang['AuthorTime']."</td>
					<td>$AuthorTime</td>
				</tr>
				<tr>
					<td>".$lang['CopperPrice']."</td>
					<td>$CopperPrice</td>
				</tr>
		";
		if(!empty($LapRace)) {
			echo "
			<tr>
				<td>".$lang['LapRace']."</td>
				<td>$LapRace</td>
			</tr>";
		}
		echo"</table>
			</p>
			</div>
		";
	}
}

function game_infos() {
	global $client, $lang, $lang_b, $server_type;
	echo '<div class="rub">
			<p class="titre">'.$lang['Game_Infos'].' '.$server_type.'</p>
			<p class="texte">';

	if (!$client->query('GetGameInfos')) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	else
	{
		$GameInfos = $client->getResponse();

		$CurrentGameInfo = $GameInfos['CurrentGameInfos'];
		$NextGameInfo = $GameInfos['NextGameInfos'];

		$ChatTime = $CurrentGameInfo['ChatTime'];
		$NbChallenge = $CurrentGameInfo['NbChallenge'];
		switch($CurrentGameInfo['GameMode']) {
			case 0:
				$GameMode = $lang['Rounds'];
			break;
			case 1:
				$GameMode = $lang['TimeAttack'];
			break;
			case 2:
				$GameMode = $lang['Team'];
			break;
			case 3:
				$GameMode = $lang['Laps'];
			break;
			case 4:
				$GameMode = $lang['Stunts'];
			break;
			default:
				$GameMode = $lang['Undefined'];
			break;
		}

		$RoundsPointsLimit = $CurrentGameInfo['RoundsPointsLimit'];
		$RoundsUseNewRules = ($CurrentGameInfo['RoundsUseNewRules']!=0) ? "True" : "False";
		if( $server_type == "TMU" ) {
			$RoundsForcedLaps = $CurrentGameInfo['RoundsForcedLaps'];
		}
		$TimeAttackLimit = $CurrentGameInfo['TimeAttackLimit'];
		$TimeAttackSynchStartPeriod = $CurrentGameInfo['TimeAttackSynchStartPeriod'];
		$TeamPointsLimit = $CurrentGameInfo['TeamPointsLimit'];
		$TeamMaxPoints = $CurrentGameInfo['TeamMaxPoints'];
		$TeamUseNewRules = ($CurrentGameInfo['TeamUseNewRules']!=0) ? "True" : "False";
		$LapsNbLaps = $CurrentGameInfo['LapsNbLaps'];
		$LapsTimeLimit = $CurrentGameInfo['LapsTimeLimit'];
		if( $server_type == "TMU" ) {
			$FinishTimeout = $CurrentGameInfo['FinishTimeout'];
		}
		$NextChatTime = $NextGameInfo['ChatTime'];
		$NextGameMode0 = $NextGameInfo['GameMode']==0 ? "selected" : "";
		$NextGameMode1 = $NextGameInfo['GameMode']==1 ? "selected" : "";
		$NextGameMode2 = $NextGameInfo['GameMode']==2 ? "selected" : "";
		$NextGameMode3 = $NextGameInfo['GameMode']==3 ? "selected" : "";
		$NextGameMode4 = $NextGameInfo['GameMode']==4 ? "selected" : "";
		$NextRoundsPointsLimit = $NextGameInfo['RoundsPointsLimit'];
		$NextRoundsUseNewRules = ($NextGameInfo['RoundsUseNewRules']!=0) ? "checked" : " ";
		if( $server_type == "TMU" ) {
			$NextRoundsForcedLaps = $NextGameInfo['RoundsForcedLaps'];
		}
		$NextTimeAttackLimit = $NextGameInfo['TimeAttackLimit'];
		$NextTimeAttackSynchStartPeriod = $NextGameInfo['TimeAttackSynchStartPeriod'];
		$NextTeamPointsLimit = $NextGameInfo['TeamPointsLimit'];
		$NextTeamMaxPoints = $NextGameInfo['TeamMaxPoints'];
		$NextTeamUseNewRules = ($NextGameInfo['TeamUseNewRules']!=0) ? "checked" : " ";
		$NextLapsNbLaps = $NextGameInfo['LapsNbLaps'];
		$NextLapsTimeLimit = $NextGameInfo['LapsTimeLimit'];
		if( $server_type == "TMU" ) {
			$NextFinishTimeout = $NextGameInfo['FinishTimeout'];
		}

		echo "
		<form name=\"input\" action=\"index.php?aff=game_infos\" method=\"post\">
		<table style=\"text-align: center\" class=\"game_infos\">
			<tr class=\"legende\">
				<td></td>
				<td>".$lang['Current']."</td>
				<td>".$lang['Next']."</td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['Mode']."</td>
				<td>$GameMode</td>
				<td>
					<select name=\"NextGameMode\" >
						<option value=\"0\" $NextGameMode0> ".$lang['Rounds']." </option>
						<option value=\"1\" $NextGameMode1> ".$lang['TimeAttack']." </option>
						<option value=\"2\" $NextGameMode2> ".$lang['Team']." </option>
						<option value=\"3\" $NextGameMode3> ".$lang['Laps']." </option>
						<option value=\"4\" $NextGameMode4> ".$lang['Stunts']." </option>
					</select>
				</td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['ChatTime']."</td>
				<td>$ChatTime</td>
				<td><input type=\"text\" name=\"NextChatTime\" value=\"$NextChatTime\"/> </td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['NbChallenge']."</td>
				<td>$NbChallenge</td>
				<td>$NbChallenge</td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['RoundsPointsLimit']."</td>
				<td>$RoundsPointsLimit</td>
				<td><input type=\"text\" name=\"NextRoundsPointsLimit\" value=\"$NextRoundsPointsLimit\"/> </td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['RoundsUseNewRules']."</td>
				<td>$RoundsUseNewRules</td>
				<td><input type=\"checkbox\" name=\"NextRoundsUseNewRules\" $NextRoundsUseNewRules/> </td>
			</tr>";
			if( $server_type == "TMU" ) {
				echo"<tr>
					<td style=\"text-align: left\">".$lang['RoundsForcedLaps']."</td>
					<td>$RoundsForcedLaps</td>
					<td><input type=\"text\" name=\"NextRoundsForcedLaps\" value=\"$NextRoundsForcedLaps\"/> </td>
				</tr>";
			}
			echo "<tr>
				<td style=\"text-align: left\">".$lang['TimeAttackLimit']."</td>
				<td>$TimeAttackLimit</td>
				<td><input type=\"text\" name=\"NextTimeAttackLimit\" value=\"$NextTimeAttackLimit\"/> </td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['TimeAttackSynchStartPeriod']."</td>
				<td>$TimeAttackSynchStartPeriod</td>
				<td><input type=\"text\" name=\"NextTimeAttackSynchStartPeriod\" value=\"$NextTimeAttackSynchStartPeriod\"/> </td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['TeamPointsLimit']."</td>
				<td>$TeamPointsLimit</td>
				<td><input type=\"text\" name=\"NextTeamPointsLimit\" value=\"$NextTeamPointsLimit\"/> </td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['TeamMaxPoints']."</td>
				<td>$TeamMaxPoints</td>
				<td><input type=\"text\" name=\"NextTeamMaxPoints\" value=\"$NextTeamMaxPoints\"/> </td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['TeamUseNewRules']."</td>
				<td>$TeamUseNewRules</td>
				<td><input type=\"checkbox\" name=\"NextTeamUseNewRules\" $NextTeamUseNewRules/> </td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['LapsNbLaps']."</td>
				<td>$LapsNbLaps</td>
				<td><input type=\"text\" name=\"NextLapsNbLaps\" value=\"$NextLapsNbLaps\"/> </td>
			</tr>
			<tr>
				<td style=\"text-align: left\">".$lang['LapsTimeLimit']."</td>
				<td>$LapsTimeLimit</td>
				<td><input type=\"text\" name=\"NextLapsTimeLimit\" value=\"$NextLapsTimeLimit\"/> </td>
			</tr>";
			if( $server_type == "TMU" ) {
				echo"<tr>
					<td style=\"text-align: left\">".$lang['FinishTimeout']."</td>
					<td>$FinishTimeout</td>
					<td><input type=\"text\" name=\"NextFinishTimeout\" value=\"$NextFinishTimeout\"/> </td>
				</tr>";
			}
			echo "<tr>
				<td colspan=\"3\" style=\"text-align: center\"><input type=\"submit\" name=\"action\" value=\"{$lang_b['SetGameInfos'][0]}\" title=\"{$lang_b['SetGameInfos'][1]}\"></td>
			</tr>
			
		</table>
		
		</form>
		</p>
	</div>";
	}
}

function upload() {
	global $client, $lang;
	
	$GetTracksDirectory = GetDirectory('GetTracksDirectory');
	if (empty($GetTracksDirectory)) echo 'Error';
	else {
		echo '<div class="rub"><p class="titre">Upload</p>';
		echo '<p class="texte" style="text-align: center">';
		echo '<form enctype="multipart/form-data" action="?aff=upload&go" method="POST" style="text-align: center">';
		echo '<table>
		<tr class="legende"><td colspan="2"><i>'.$lang['Overwrite'].'</i></td></tr>
		<tr><td>'.$lang['Upload_this_file'].'</td><td><input name="file" type="file" size="50" /></td></tr>
		<tr><td>'.$lang['into'].'</td><td>'.$GetTracksDirectory.'</td></tr>
		';
		echo '</table><input type="submit" value="Uploader" />';
		echo "</p>\n";
		echo '</form></div>';
	}
}

function upload_go($file, $folder) {
	global $lang, $client, $lang_b;
	$MAX_SIZE = 5000000;
	echo '<center>';
	if(!empty($file["name"])){
		// Nom du fichier choisi:
		$nomFichier = $file["name"] ;
		// Nom temporaire sur le serveur:
		$nomTemporaire = $file["tmp_name"] ;
		// Type du fichier choisi:
		$typeFichier = $file["type"] ;
		// Poids en octets du fichier choisit:
		$poidsFichier = $file["size"] ;
		// Code de l'erreur si jamais il y en a une:
		$codeErreur = $file["error"] ;
		// Extension du fichier
		$extension = strtolower(strstr($nomFichier, "."));
		// Si le poids du fichier est de 0 bytes, le fichier est
		// invalide (ou le chemin incorrect) => message d'erreur
		// sinon, le script continue.
		if($poidsFichier <> 0){
			// Si la taille du fichier est supérieure à la taille
			// maximum spécifiée => message d'erreur
			if($poidsFichier < $MAX_SIZE){
				// On teste ensuite si le fichier a une extension autorisée
				if($extension == ".challenge.gbx"){
					$filename = $folder.$nomFichier ;
					
					$str = file_get_contents($nomTemporaire);
					$str64 = new IXR_Base64($str);
					if ($client->query('WriteFile',$nomFichier,$str64)) {
						$res = $client->getResponse();
						if($res) echo $lang['Upload_ok']."<br />". $filename;
						//var_dump($res);
						$dossier_relatif = substr($folder, strlen(GetDirectory('GetTracksDirectory')));
						echo '<form name="input" action="index.php?aff=challenges" method="post">
							<input type="hidden" name="ChallengeFileName" value="'.$dossier_relatif.$nomFichier.'" />
							<input type="submit" name="action" value="'.$lang_b['AddChallenge'][0].'" title="'.$lang_b['AddChallenge'][1].'" />
							<input type="submit" name="action" value="'.$lang_b['InsertChallenge'][0].'" title="'.$lang_b['InsertChallenge'][1].'" />
						</form>';
					}else{
						print "Can't do/get WF !  Error ".$client->getErrorCode().": ".$client->getErrorMessage()."\n";
					}
				}
				else echo $lang['bad_extension'];
			}
			else {
				$tailleKo = $MAX_SIZE / 1000;
				echo $lang['bad_size']." $tailleKo Ko";
			}	
		}
		else echo $lang['file_corrupt'];
	}
	else echo $lang['no_file'];
	echo '</center>';
}

function chatcommand() {
	global $client, $lang, $lang_b, $server_type;
	
	if( $server_type != "TMU") {
		echo '<div class="rub">
				<p class="titre">'.$lang['CommandChat'].'</p>
				<p class="texte">';
		if (!$client->query('GetChatCommandList', 20, 0)) {
		trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
		}
		else {
			$chatcommand = $client->getResponse();
			$max = count($chatcommand);
			if($max == 0) echo $lang['NoCommandChat'];
			else {
				$i = 0;
				echo '<table class="none"><tr>';
				foreach($chatcommand as $piece) {
					$i++;
					echo '<td>'.$piece['Name'].'</td>
							<td>
							<form action="index.php?aff=chat" method="post">
								<input type="hidden" name="ChatCommand" value="'.$piece['Name'].'">
								<input type="submit" name="action" value="'.$lang_b['RemoveChatCommand'][0].'" title="'.$lang_b['RemoveChatCommand'][1].'">
							</form>
							</td>';
					if($i == $max AND !is_int($max/2)) echo "<td></td>\n<td></td>\n";
					if(is_int($i/2)) {
						echo "</tr>";
						if($i != $max)  echo "<tr>\n";
					}
				}
				echo '</table>';
			}
		}
		echo '<hr style="margin: 10px 100px" /><form style="text-align: center" action="index.php?aff=chat" method="post">
				<input type="text" name="ChatCommand">
				<input type="submit" name="action" value="'.$lang_b['AddChatCommand'][0].'" title="'.$lang_b['AddChatCommand'][1].'">
				<input type="submit" name="action" value="'.$lang_b['CleanChatCommand'][0].'" title="'.$lang_b['CleanChatCommand'][1].'">
			</form>';
		echo '</p></div>';
	}
}

// recherche du type de serveur 
function get_server_type() {
	global $client;
	if (!$client->query('GetVersion')) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	$Serveur = $client->getResponse();
	switch ($Serveur['Name']) {
      case "TmNationsESWC":
        return "TMN";
      case "TmSunrise":
        return "TMS";
      case "TmOriginal":
        return "TMO";
      case "TmUnited":
      case "TmUnited.":
        return "TMU";
    }	
}

?>
