<?php
session_name("InterfaceWebTM");
session_cache_expire (30);
session_start();

header("Cache-Control: no-cache, must-revalidate");
header('Content-Type: text/html; charset=UTF-8'); 

require_once('config.php');
require_once('GbxRemote.inc.php');
require_once('connection.php');
require_once('functions.php');
if(isset($_SESSION['lang_perso'])) require_once("lang/".$_SESSION['lang_perso'].".php");
else require_once("lang/".LANG_DEFAULT.".php");

//----------------------


// ----------------------------------

if(!$client->query("Authenticate", $_SESSION['authLogin'][$_SESSION['serveur']], $_SESSION['authPassword'][$_SESSION['serveur']])) {
	echo "<center>";
	trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	echo "</center>";
}
else {
	if (!$client->query('GetStatus')) {
	   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
	}
	else {
		$Status = $client->getResponse();
		?>
		<form name="input" action="index.php" method="post">
			<table align="center" >
			<tr>
				<td><?php echo $lang['Status']; ?></td>
				<td> <span style="color: blue"><?php echo $Status['Name']; ?></span></td>
			</tr>
		<?php
		if ($Status['Code'] == 1) {
			// start server
			?>
			<tr>
				<td><?php echo $lang['Master_Server_Login']; ?></td>
				<td><input type="text" name="Login" size="30" value="" onFocus="document.actualiser.auto.checked = false" /></td>
			</tr>
			<tr>
				<td><?php echo $lang['Master_Server_Password']; ?></td>
				<td><input type="password" name="Password" size="30" value=""/></td>
			</tr>
			<tr>
				<td colspan="2" style="text-align:center">
					<input type="submit" name="action" value="<?php echo $lang_b['QuitGame'][0]; ?>" title="<?php echo $lang_b['QuitGame'][1]; ?>" style="background:url(./icons/off_icon.gif) no-repeat; background-position: left center; padding-left: 16px">
					<input type="submit" name="action" value="<?php echo $lang_b['StartServerLan'][0]; ?>" style="background:url(./icons/play_icon.gif) no-repeat; background-position: left center; padding-left: 16px" title="'.$lang_b['StartServerLan'][1]; ?>">
					<input type="submit" name="action" value="<?php echo $lang_b['StartServerInternet'][0]; ?>" style="background:url(./icons/play_icon.gif) no-repeat; background-position: left center; padding-left: 16px" title="<?php echo $lang_b['StartServerInternet'][1]; ?>">
				</td>
			</tr>
		<?php
		} else if ( ($Status['Code'] == 3) OR ($Status['Code'] == 4) OR ($Status['Code'] == 5) ) {
			if (!$client->query('GetCurrentChallengeInfo')) {
			   trigger_error("[".$client->getErrorCode()."] ".$client->getErrorMessage());
			}
			else {
				$CurrentChallengeInfo = $client->getResponse();
			?>
			<tr>
				<td class="sstitre" colspan="2"><?php echo $lang['Current_challenge']; ?></td>
			</tr>
			<tr><td><?php echo $lang['Name']; ?></td><td><?php echo Couleur($CurrentChallengeInfo['Name'])." - ".$CurrentChallengeInfo['Name']; ?></td></tr>
			<tr><td><?php echo $lang['UId']; ?></td><td><?php echo $CurrentChallengeInfo['UId']; ?></td></tr>
			<tr><td><?php echo $lang['Author']; ?></td><td><?php echo $CurrentChallengeInfo['Author']; ?></td></tr>
			<?php
			if( get_server_type() != "TMN" ) {
				echo "<tr><td>".$lang['Environnemnent']."</td><td>".$CurrentChallengeInfo['Environnement']."</td></tr>";
			}	
			?>
			<?php
				//".Couleur($CurrentChallengeInfo['Name'])." <br />(".$CurrentChallengeInfo['UId'].") - <b>".$CurrentChallengeInfo['Name']."</b> - ".$CurrentChallengeInfo['Author'] . "<br />";
			}
			// in game actions
			if( $Status['Code'] == 4 ) {
				echo '
				<tr><td colspan="2" style="text-align: center">
					<input type="submit" name="action" value="'.$lang_b['ChallengeRestart'][0].'" title="'.$lang_b['ChallengeRestart'][1].'" style="background:url(./icons/restart_icon.gif) no-repeat; background-position: left center; padding-left: 16px" />
					<input type="submit" name="action" value="'.$lang_b['NextChallenge'][0].'" title="'.$lang_b['NextChallenge'][1].'" style="background:url(./icons/next_icon.gif) no-repeat; background-position: left center; padding-left: 16px" />
					<input type="submit" name="action" value="'.$lang_b['StopServer'][0].'" title="'.$lang_b['StopServer'][1].'" style="background:url(./icons/stop_icon.png) no-repeat; background-position: left center; padding-left: 16px" />
					</td>
				</tr>
				';
			}
		}
		?>
		</table>
		</form>
		<?php
	}
}
$client->Terminate();
?>
